      implicit none
      integer i,n,intm,int,iwant2,iwant3
      real a,b,h,x,y,xl,yl,f
      real yp,k1,k2,k3,k4,y0
      real yexact,yex,err,errp

      print*,' Enter 1 for Euler'
      print*,'       2 for Improved Euler'
      print*,'       3 for 4th order Runge-Kutta'
      print*,'       4 for all of them'
      read(5,*) intm
      if(intm.eq.4) then
         int=0
      else
         int=intm
      endif
      print*,' Enter n'
      read(5,*) n
      print*,' Enter x(0),x(n),y(0)'
      read(5,*) a,b,y0

      h=(b-a)/float(n)


 100  continue
      y=y0
      x=a

      if(intm.eq.4) int=int+1

	if(int.eq.2) then
C		write(6,*) ' Want to see predicted value ? 1=yes'
C		read(5,*) iwant2
	endif

	if(int.eq.3) then
C		write(6,*) ' Want to see k values ? 1=yes'
C		read(5,*) iwant3
	endif

      if(int.eq.1) then
         write(6,10) x,y,yexact(x)
      else if(int.eq.2) then
         write(6,20) x,y,yexact(x)
      else if(int.eq.3) then
         write(6,30) x,y,yexact(x)
      endif

 10   format(/,' Solving with Euler gives:',/,
     &         '   X        Y         exact',
     &         '     % error   %err/i*h^2',/,
     &         1x,f5.3,1x,f10.6,1x,f10.6)   
 20   format(/,' Solving with Improved Euler gives:',/,
     &         '   X        Y         exact',
     &         '     % error   err/i*h^3',/,
     &         1x,f5.3,1x,f10.6,1x,f10.6)
 30   format(/,' Solving with 4th Runge-Kutta gives:',/,
     &         '   X        Y         exact',
     &         '     % error   err/i*h^5',/,
     &         1x,f5.3,1x,f10.6,1x,f10.6)

      if(int.eq.1) then
        do i=1,n
           xl=x
           yl=y
           x=xl+h
           y=yl+h*f(xl,yl)
           yex=yexact(x)
           err=abs((y-yex)/yex)
           errp=100.*err
           write(6,2) x,y,yex,errp,err/(float(i)*h*h)
 2         format(1x,f5.3,1x,f10.6,1x,f10.6,3x,1pe10.3,1x,e10.3)
        enddo
      else if(int.eq.2) then
        do i=1,n
           xl=x
           yl=y
           yp=yl+h*f(xl,yl)
	   if(iwant2.eq.1) write(6,*) '    predicted y=',yp
           x=xl+h
           y=yl+0.5*h*(f(xl,yl)+f(x,yp))
           yex=yexact(x)
           err=abs((y-yex)/yex)
           errp=100.*err
           write(6,2) x,y,yex,errp,err/(float(i)*h**3)
        enddo
      else if(int.eq.3) then
        do i=1,n
           xl=x
           yl=y
           k1=h*f(xl,yl)
           k2=h*f(xl+0.5*h,yl+0.5*k1)
           k3=h*f(xl+0.5*h,yl+0.5*k2)
           k4=h*f(xl+h,yl+k3)
	   if(iwant3.eq.1) write(6,*) '    k=',k1,k2,k3,k4
           x=xl+h
           y=yl+(k1+2*k2+2*k3+k4)/6.0
           yex=yexact(x)
           err=abs((y-yex)/yex)
           errp=100.*err
           write(6,3) x,y,yex,errp,err/(float(i)*h**5)
 3         format(1x,f5.3,1x,f10.6,1x,f10.6,3x,1pe10.3,1x,e10.3)
         enddo
      endif

      if(intm.eq.4.and.int.lt.3) go to 100
      stop
      end


      real function f(x,y)
      implicit none
      real x,y
      f=y
      return
      end

      real function yexact(x)
      implicit none
      real x
      yexact=exp(x)
      return
      end
