      implicit none
      integer i,n,intm,int,iwant2,iwant3
      real a,b,h,x,y,z,xl,yl,zl,f,g
      real yp,k1,k2,k3,k4,y0
      real zp,l1,l2,l3,l4,z0
      real yexact,yex,err

      print*,' Enter 1 for Euler'
      print*,'       2 for Improved Euler'
      print*,'       3 for 4th order Runge-Kutta'
      print*,'       4 for all of them'
      read(5,*) intm
      if(intm.eq.4) then
         int=0
      else
         int=intm
      endif
      print*,' Enter n'
      read(5,*) n
      print*,' Enter x(0),x(n),y(0),z(0)'
      read(5,*) a,b,y0,z0

      h=(b-a)/float(n)


 100  continue
      z=z0
      y=y0
      x=a

      if(intm.eq.4) int=int+1

	if(int.eq.2) then
C		write(6,*) ' Want to see predicted value ? 1=yes'
C		read(5,*) iwant2
	endif

	if(int.eq.3) then
C		write(6,*) ' Want to see k values ? 1=yes'
C		read(5,*) iwant3
	endif

      if(int.eq.1) then
         write(6,10) x,y0,z0,yexact(x)
      else if(int.eq.2) then
         write(6,20) x,y0,z0,yexact(x)
      else if(int.eq.3) then
         write(6,30) x,y0,z0,yexact(x)
      endif

 10   format(/,' Solving with Euler gives:',/,
     &         '   X         Y          Z        exact',/,
     &         1x,f5.3,1x,f10.6,1x,f10.6,1x,f10.6)   
 20   format(/,' Solving with Improved Euler gives:',/,
     &         '   X         Y          Z        exact',/,
     &         1x,f5.3,1x,f10.6,1x,f10.6,1x,f10.6)
 30   format(/,' Solving with 4th Runge-Kutta gives:',/,
     &         '   X         Y          Z        exact',/,
     &         1x,f5.3,1x,f10.6,1x,f10.6,1x,f10.6) 

      if(int.eq.1) then
        do i=1,n
           xl=x
           yl=y
           zl=z
           x=xl+h
           y=yl+h*f(xl,yl,zl)
           z=zl+h*g(xl,yl,zl)
           yex=yexact(x)
           err=abs((y-yex)/yex)
           write(6,2) x,y,z,yex
 2         format(1x,f5.3,1x,f10.6,1x,f10.6,1x,f10.6)
        enddo
      else if(int.eq.2) then
        do i=1,n
           xl=x
           yl=y
           zl=z
           yp=yl+h*f(xl,yl,zl)
           zp=zl+h*g(xl,yl,zl)
	   if(iwant2.eq.1) write(6,*) '    predicted y=',yp
           x=xl+h
           y=yl+0.5*h*(f(xl,yl,zl)+f(x,yp,zp))
           z=zl+0.5*h*(g(xl,yl,zl)+g(x,yp,zp))
           yex=yexact(x)
           err=abs((y-yex)/yex)
           write(6,2) x,y,z,yex
        enddo
      else if(int.eq.3) then
        do i=1,n
           xl=x
           yl=y
           zl=z
           k1=h*f(xl,yl,zl)
           l1=h*g(xl,yl,zl)
           k2=h*f(xl+0.5*h, yl+0.5*k1, zl+0.5*l1)
           l2=h*g(xl+0.5*h, yl+0.5*k1, zl+0.5*l1)
           k3=h*f(xl+0.5*h, yl+0.5*k2, zl+0.5*l2)
           l3=h*g(xl+0.5*h, yl+0.5*k2, zl+0.5*l2)
           k4=h*f(xl+h,     yl+k3,     zl+l3)
           l4=h*g(xl+h,     yl+k3,     zl+l3)
	   if(iwant3.eq.1) write(6,*) '    k=',k1,k2,k3,k4
           x=xl+h
           y=yl+(k1+2.*k2+2.*k3+k4)/6.0
           z=zl+(l1+2.*l2+2.*l3+l4)/6.0
           yex=yexact(x)
           err=abs((y-yex)/yex)
           write(6,3) x,y,z,yex
 3         format(1x,f5.3,1x,f10.6,1x,f10.6,1x,f10.6)
         enddo
      endif

      if(intm.eq.4.and.int.lt.3) go to 100
      stop
      end


      real function f(x,y,z)
      implicit none
      real x,y,z
      f=z
      return
      end


      real function g(x,y,z)
      implicit none
      real x,y,z
      g=-sin(x)
      return
      end


      real function yexact(x)
      implicit none
      real x
      yexact=sin(x)
      return
      end
