      implicit none
      integer i,n,int,iwant2,iwant3,j,k
      integer n1,n2,n3,cindex
      real a,b,h,x,y,z,xl,yl,zl,f,g,exact
      real yp,zp,k1,k2,k3,k4,y0,zero
      real l1,l2,l3,l4,z0
      real h1,h2,h3,yemin,yemax
      real xval(3,1000),yval(3,1000)
      real e1,e2,e3,xmin,xmax,ymin,ymax
      real xplot1(1000),yplot1(1000)
      real xplot2(1000),yplot2(1000)
      real xplot3(1000),yplot3(1000)

      real xerr1(1000),yerr1(1000)
      real xerr2(1000),yerr2(1000)
      real xerr3(1000),yerr3(1000)
      real yexact(1000)
      real xplote1(1000),yplote1(1000)
      real xplote2(1000),yplote2(1000)
      real xplote3(1000),yplote3(1000)

C     The suffix tells which integratioin we are doing
C         1 for Euler
C         2 for Improved Euler
C         3 for RK4
C     
C     This suffix used for the approprite h and n

      print*,' Enter n for RK4'
      read(5,*) n
      write(6,20) 4*n,2*n,n
      print*,' Enter a,b,y(a),z(a)'
      read(5,*) a,b,y0,z0
      write(6,21) a,y0,z0,b

 20   format('  Using n=',i3,' for Euler',/
     &       '        n=',i3,' for Improved Euler',/
     &       '        n=',i3,' for Runge-Kutta 4')

 21   format('  Initial      x = ',f6.4,' with y = ',f6.4,
     &       '  and dy/dx = ',f6.4,/,'  Integrate to x = ',f6.4)

      n1=4*n
      n2=2*n
      n3=n
      h1=(b-a)/float(n1)
      h2=(b-a)/float(n2)
      h3=(b-a)/float(n3)

      ymin=100
      ymax=-100
      yemin=100
      yemax=-100

C     iwant used for debugging - shows predictor and k values...
      iwant2=0
      iwant3=0
      zero=0.0

      write(6,10) a,y0,y0,y0,y0
 10   format(/,' Solving with Euler  I Euler        RK4        Exact',/,
     &         '   X        Y           Y            Y           Y',/,
     &        1x,f5.3,   1x,1pe11.4, 1x, e11.4, 1x, e11.4, 1x, e11.4)   


C EULER
      y=y0
      z=z0
      x=a
      do i=1,n1
         xl=x
         yl=y
         zl=z
         x=xl+h1
         y=yl+h1*f(xl,yl,zl)
         z=zl+h1*g(xl,yl,zl)
         xval(1,i)=x
         yval(1,i)=y
         ymin=min(ymin,y)
         ymax=max(ymax,y)
      enddo


C IMPROVED EULER
      y=y0
      x=a
      z=z0
      do i=1,n2
         xl=x
         yl=y
         zl=z
         yp=yl+h2*f(xl,yl,zl)
         zp=zl+h2*g(xl,yl,zl)
         if(iwant2.eq.1) write(6,*) '    predicted y=',yp
         x=xl+h2
         y=yl+0.5*h2*(f(xl,yl,zl)+f(x,yp,zp))
         z=zl+0.5*h2*(g(xl,yl,zl)+g(x,yp,zp))
         xval(2,i)=x
         yval(2,i)=y
         ymin=min(ymin,y)
         ymax=max(ymax,y)
      enddo


C 4TH ORDER RUNGE-KUTTA
      y=y0
      z=z0
      x=a
      do i=1,n3
         xl=x
         yl=y
         zl=z
         k1=h3*f(xl,yl,zl)
         l1=h3*g(xl,yl,zl)
         k2=h3*f(xl+0.5*h3,yl+0.5*k1,zl+0.5*l1)
         l2=h3*g(xl+0.5*h3,yl+0.5*k1,zl+0.5*l1)
         k3=h3*f(xl+0.5*h3,yl+0.5*k2,zl+0.5*l2)
         l3=h3*g(xl+0.5*h3,yl+0.5*k2,zl+0.5*l2)
         k4=h3*f(xl+h3,yl+k3,zl+l3)
         l4=h3*g(xl+h3,yl+k3,zl+l3)
         if(iwant3.eq.1) write(6,*) '    k=',k1,k2,k3,k4
         x=xl+h3
         y=yl+(k1+2*k2+2*k3+k4)/6.0
         z=zl+(l1+2*l2+2*l3+l4)/6.0
         xval(3,i)=x
         yval(3,i)=y
         ymin=min(ymin,y)
         ymax=max(ymax,y)
      enddo



C PRINT OUT RESULTS
C Clever juggling of indices to get them all in one loop :-)

      do i=1,n1,4
         write(6,31) xval(1,i),yval(1,i),exact(xval(1,i))

         j=(i+1)/2
         write(6,32) xval(1,i+1),yval(1,i+1),yval(2,j),
     &                                       exact(xval(1,i+1))

         write(6,33) xval(1,i+2),yval(1,i+2),exact(xval(1,i+2))

         j=(i+3)/2
         k=(i+3)/4
         write(6,34) xval(1,i+3),yval(1,i+3),yval(2,j),yval(3,k),
     &                                       exact(xval(1,i+3))
      enddo

 31   format(1x,f5.3,1x,1pe11.4,25x,e11.4)
 32   format(1x,f5.3,1x,1pe11.4,1x,e11.4,12x,1x,e11.4)
 33   format(1x,f5.3,1x,1pe11.4,25x, e11.4)
 34   format(1x,f5.3,1x,1pe11.4,1x,e11.4,1x,e11.4,1x,e11.4)



C     NOW LOOK AT ERRORS - FRACTIONAL AND LOG

      write(6,11) a,zero,zero,zero,zero,zero,zero
 11   format(///,' Errors: Fractional and log(fractional)  with:',/,
     &           '   X          Euler        ',
     &           '          I Euler          Runge-Kutta 4  ',/,
     &           '           Frac      Log     ',
     &           '    Frac      Log     ',
     &           '   Frac      Log ',/,
     &           1x,f5.3,1x,1pe9.2,1x,e9.2,3x,e9.2,1x,e9.2,
     &           3x,e9.2,1x,e9.2)



      do i=1,n1,4
         e1=(yval(1,i)-exact(xval(1,i)))/exact(xval(1,i))
         write(6,41) xval(1,i),e1,log10(abs(e1))
         yerr1(i+1)=log10(abs(e1))

         j=(i+1)/2
         e1=(yval(1,i+1)-exact(xval(1,i+1)))/exact(xval(1,i+1))
         e2=(yval(2,j)-  exact(xval(1,i+1)))/exact(xval(1,i+1))
         write(6,42) xval(1,i+1),e1,log10(abs(e1)),e2,log10(abs(e2))
         yerr1(i+2)=log10(abs(e1))
         yerr2(j+1)=log10(abs(e2))

         e1=(yval(1,i+2)-exact(xval(1,i+2)))/exact(xval(1,i+2))
         write(6,43) xval(1,i+2),e1,log10(abs(e1))
         yerr1(i+3)=log10(abs(e1))

         j=(i+3)/2
         k=(i+3)/4
         e1=(yval(1,i+3)-exact(xval(1,i+3)))/exact(xval(1,i+3))
         e2=(yval(2,j)-  exact(xval(1,i+3)))/exact(xval(1,i+3))
         e3=(yval(3,k)-  exact(xval(1,i+3)))/exact(xval(1,i+3))
         write(6,44) xval(1,i+3),e1,log10(abs(e1)),e2,
     &                       log10(abs(e2)),e3,log10(abs(e3))
         yerr1(i+4)=log10(abs(e1))
         yerr2(j+1)=log10(abs(e2))
         yerr3(k+1)=log10(abs(e3))
      enddo

 41   format(1x,f5.3,1x,1pe9.2,1x,e9.2)
 42   format(1x,f5.3,1x,1pe9.2,1x,e9.2,3x,e9.2,1x,e9.2)
 43   format(1x,f5.3,1x,1pe9.2,1x,e9.2)
 44   format(1x,f5.3,1x,1pe9.2,1x,e9.2,3x,e9.2,1x,e9.2,
     &       3x,e9.2,1x,e9.2)



C---PGPLOT SOLUTIOIN

      xmin=a
      xmax=b
      CALL PGBEG(0,'?',1,1)
      call pgpap(10.0,0.8)
      call pgsci(1)

      xmin=min(xmin,a)
      xmin=min(xmin,b)
      xmax=max(xmax,a)
      xmax=max(xmax,b)
      ymin=min(ymin,y0)
      ymax=max(ymax,y0)


      xplot1(1)=a
      xplot2(1)=a
      xplot3(1)=a
      yplot1(1)=y0
      yplot2(1)=y0
      yplot3(1)=y0
      yexact(1)=y0

      do i=1,n1+1
         xplot1(i+1)=xval(1,i)
         yplot1(i+1)=yval(1,i)
      enddo

      do i=1,n2+1
         xplot2(i+1)=xval(2,i)
         yplot2(i+1)=yval(2,i)
      enddo

      do i=1,n3+1
         xplot3(i+1)=xval(3,i)
         yplot3(i+1)=yval(3,i)
      enddo

C EXACT SOLUTION
      do i=1,n1
         x=xplot1(i+1)
         yexact(i+1)=exact(x)
         ymin=min(ymin,yexact(i+1))
         ymax=max(ymax,yexact(i+1))
      enddo

C     Set up max and min allowing for negative numbers :-/
      if(xmin.gt.0) xmin = 0.98*xmin
      if(ymin.gt.0) ymin = 0.98*ymin

      if(xmin.lt.0) xmin = 1.02*xmin
      if(ymin.lt.0) ymin = 1.02*ymin

      if(xmax.gt.0) xmax = 1.02*xmax
      if(ymax.gt.0) ymax = 1.02*ymax

      if(xmax.lt.0) xmax = 0.98*xmax
      if(ymax.lt.0) ymax = 0.98*ymax

      call pgenv(xmin,xmax,ymin,ymax,0,0)
      call pglabel('X', 'Y', 
     &   'Solutions:   E(white)   IE(Red)   RK4(Green)   Exact(Blue)')

      call pgsci(1)
      call pgline(n1+1,xplot1,yplot1)
      call pgpoint(n1+1,xplot1,yplot1,254)

      call pgsci(2)
      call pgline(n2+1,xplot2,yplot2)
      call pgpoint(n2+1,xplot2,yplot2,254)

      call pgsci(3)
      call pgline(n3+1,xplot3,yplot3)
      call pgpoint(n3+1,xplot3,yplot3,254)

      call pgsci(4)
      call pgline(n1+1,xplot1,yexact)
C      call pgpoint(n1+1,xplot1,yexact,254)

      call pgend



C---PGPLOT ERRORS
      xmin=a
      xmax=b
      CALL PGBEG(0,'?',1,1)
      call pgpap(10.0,0.8)

C      yerr1(1)=0.0
C      yerr2(1)=0.0
C      yerr3(1)=0.0

      yemin=100
      yemax=-100

      do i=2,n1+1
         yemin=min(yemin,yerr1(i))
         yemax=max(yemax,yerr1(i))
      enddo

      do i=2,n2+1
         yemin=min(yemin,yerr2(i))
         yemax=max(yemax,yerr2(i))
      enddo

      do i=2,n3+1
         yemin=min(yemin,yerr3(i))
         yemax=max(yemax,yerr3(i))
      enddo

C     Set up max and min allowing for negative numbers :-/
C     xmin and xmax do not change


      if(yemin.gt.0) yemin = 0.98*yemin
      if(yemin.lt.0) yemin = 1.02*yemin
      if(yemax.gt.0) yemax = 1.02*yemax
      if(yemax.lt.0) yemax = 0.98*yemax
      xmax=1.02*xmax
C      write(6,*) xmin,xmax,yemin,yemax
      call pgenv(xmin,xmax,yemin,yemax,0,0)


      call pglabel('X', 'Log10(error)', 
     &             'Log10 Magnitude Fractional Errors:'
     &             //'   E(white),  IE(Red),  RK4(Green)')

C     Actually, do not want the fisrt point as erro is zero!
C     So shift everything by one....

      do i=1,n1
         xplote1(i)=xplot1(i+1)
         yplote1(i)=yerr1(i+1)
      enddo


      do i=1,n2
         xplote2(i)=xplot2(i+1)
         yplote2(i)=yerr2(i+1)
      enddo


      do i=1,n3
         xplote3(i)=xplot3(i+1)
         yplote3(i)=yerr3(i+1)
      enddo

      call pgsci(1)
      call pgline(n1,xplote1,yplote1)
      call pgpoint(n1,xplote1,yplote1,254)

      call pgsci(2)
      call pgline(n2,xplote2,yplote2)
      call pgpoint(n2,xplote2,yplote2,254)

      call pgsci(3)
      call pgline(n3,xplote3,yplote3)
      call pgpoint(n3,xplote3,yplote3,254)

      call pgend

      stop
      end


      real function f(x,y,z)
      implicit none
      real x,y,z
      f=z
      return
      end


      real function g(x,y,z)
      implicit none
      real x,y,z
      g=-sin(x)
      return
      end


      real function exact(x)
      implicit none
      real x
      exact=sin(x)
      return
      end





