      implicit none
      real*8 x,y,h,hmax,hmin,hreject
      real*8 a,b,y0,ynew
      real*8 f,exact,zero
      real*8 dh(6),xarg,yarg
      real*8 k1,k2,k3,k4,k5,k6
      real*8 tol,R,delta

      integer icount,iout,ireject


      dh(1)=0.
      dh(2)=1./4.
      dh(3)=3./8.
      dh(4)=12./13.
      dh(5)=1.
      dh(6)=1./2.

C     Place restrictions on hmin
      hmin=tol

      write(6,*) 'Enter a,b,y(a)'
      read(5,*) a,b,y0
      x=a
      y=y0
      zero=0.0

C      write(6,*) 'Output every iout steps: Enter iout'
C      read(5,*) iout
      iout=1
      write(6,*) 'Enter maximum error and maximum step length'
      read(5,*) tol,hmax


C     Start with h=hmin=tol
      h=tol
      hmin=tol

      print 11
 11   format(/,'      x         y       exact      |error|    h')
      write(6,10) x,y,y,zero,h

      icount=0

 100  continue

      k1=h*f(x,y)

      xarg=x+dh(2)*h
      yarg=y+k1*0.25
      k2=h*f(xarg,yarg)

      xarg=x+dh(3)*h
      yarg=y+3.*(k1+3.*k2)/32.
      k3=h*f(xarg,yarg)

      xarg=x+dh(4)*h
      yarg=y+(1932.*k1-7200.*k2+7296.*k3)/2197.
      k4=h*f(xarg,yarg)

      xarg=x+dh(5)*h
      yarg=y+439.*k1/216.-8.*k2+3680.*k3/513.-845.*k4/4104.
      k5=h*f(xarg,yarg)

      xarg=x+0.5*h
      yarg=y-8.*k1/27.+2.*k2-3544.*k3/2565.+ 
     &    1859.*k4/4104.-11.*k5/40.
      k6=h*f(xarg,yarg)


C     Error controlling R value
      R=abs(k1/360.-128.*k3/4275.-2197.*k4/75240.+
     &     k5/50.+2.*k6/55.)/h
      if(R.ne.0) delta=0.84*(tol/R)**0.25

C     if R < tol then this step is accepted.....
      ireject=0
      if(R.le.tol) then
         ynew=y+25.*k1/216.+1408.*k3/2565.+2197.*k4/4104.-0.2*k5
         y=ynew
         x=x+h
C        If required, print out the x,y and h for this step
	 icount=icount+1
         if(mod(icount,iout).eq.0) write(6,10) x,y,exact(x),
     &                abs(exact(x)-y),h
      else
C        Here R > tol, so we must reduce h.
C        This step is NOT accepted.
         hreject=h
         ireject=1
      endif

C     Now adjust h
      if(delta.le.0.5) then
         h=0.5*h
      else if (delta.gt.2) then
         h=2.*h
      else
         h=delta*h
      endif
      if(ireject.eq.1) write(6,20) hreject,h

      if(h.gt.hmax) h = hmax
      if(h.lt.hmin) h = hmin
      if(x.lt.b) go to 100


C     FORMAT statements
10    format(2x,f8.5,2x,f8.6,2x,f8.6,2x,1pe11.4,2x,0pf5.3)
20    format('   Error predicted too large with h=',f5.3,
     &       ' - reduce h to ',f5.3)

      end



C     f is f(x,y)=dy/dz
      real*8 function f(x,y)
      real*8 x,y
      f=y
C      f = -(1./x/x) - 4.*(x-6.)*exp(-2.*(x-6)**2)
      return
      end


C     exact is the analytical solution
      real*8 function exact(x)
      real*8 x
      exact=exp(x)
C      exact=1/x + exp(-2.*(x-6)**2)
      return
      end

